'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var BREAK = {};
var DATA = Symbol('data');

/*----------------------------------------------------------------------------*/

var MapCache = function () {
  function MapCache(entries) {
    _classCallCheck(this, MapCache);

    this[DATA] = new Map(entries);
    _lodash2.default.bindAll(this[DATA], ['entries', 'forEach', 'keys', 'values']);
  }

  _createClass(MapCache, [{
    key: 'clear',
    value: function clear() {
      this[DATA].clear();
      return this;
    }
  }, {
    key: 'delete',
    value: function _delete(key) {
      return this[DATA].delete(key);
    }
  }, {
    key: 'findKey',
    value: function findKey(iteratee) {
      var result = void 0;
      try {
        this[DATA].forEach(function (value, key, map) {
          if (iteratee(value, key, map)) {
            result = key;
            throw BREAK;
          }
        });
      } catch (e) {
        if (e !== BREAK) {
          throw e;
        }
      }
      return result;
    }
  }, {
    key: 'get',
    value: function get(key) {
      return this[DATA].get(key);
    }
  }, {
    key: 'has',
    value: function has(key) {
      return this[DATA].has(key);
    }
  }, {
    key: 'set',
    value: function set(key, value) {
      this[DATA].set(key, value);
      return this;
    }
  }, {
    key: 'entries',
    get: function get() {
      return this[DATA].entries;
    }
  }, {
    key: 'forEach',
    get: function get() {
      return this[DATA].forEach;
    }
  }, {
    key: 'keys',
    get: function get() {
      return this[DATA].keys;
    }
  }, {
    key: 'size',
    get: function get() {
      return this[DATA].size;
    }
  }, {
    key: 'values',
    get: function get() {
      return this[DATA].values;
    }
  }, {
    key: Symbol.iterator,
    get: function get() {
      return this[DATA].entries;
    }
  }]);

  return MapCache;
}();

exports.default = MapCache;
;
module.exports = exports['default'];